/*****************************************************
CodeWizardAVR V2.05.0 Advanced
Project : Voltmeter digital
Version : 
Date    : 3/20/2014
Author  : Priyo Harjiyono
Company : http://anotherorion.com
*****************************************************/
#include <mega16.h>
#include <delay.h>
#include <alcd.h>
#include <stdio.h>
#define ADC_VREF_TYPE 0x00
unsigned int read_adc(unsigned char adc_input)
{
ADMUX=adc_input | (ADC_VREF_TYPE & 0xff);
delay_us(10);
ADCSRA|=0x40;
while ((ADCSRA & 0x10)==0);
ADCSRA|=0x10;
return ADCW;
}
char buff[33];
int masukan;
float hitung;
void main(void)
{
ADMUX=ADC_VREF_TYPE & 0xff;
ADCSRA=0xA1;
SFIOR&=0x1F;
lcd_init(16);
while (1)
      {
      lcd_gotoxy(0,0);
      lcd_putsf("V meter digital");
      masukan = read_adc(0);
      hitung = (float) masukan*5/1024;
      sprintf(buff," V input : %0.2f", hitung);
      lcd_gotoxy(0,1);
      lcd_puts(buff);
      delay_ms(100);
      lcd_clear();
      }
}
